#if defined(BAHAMUT)
# define cmodeless       "-ovb"
#elif defined(UNREAL)
# define cmodeless       "-ohvbaqe"
#elif defined(IRC_DALNET)
# define cmodeless       "-ovb"
#elif defined(TITAN)
# define cmodeless       "-ohvbaqe"
#else
# define cmodeless       "-ovub"
#endif

#ifdef CR
# define RMODE	"+R"
# define URMODE	"-R"
#else
# define RMODE	"+r"
# define URMODE	"-r"
#endif

#if defined(UNREAL)
# define IRCD       "Unreal"
# define NETADMIN
# define SWHOIS
# define DEFHALFOP
# define DEFPROTECT
# define DEFHOSTSERV
# define CLINK
# define CFLOOD
# define SJOIN
# define SJ3
# define NICKV2
# define CFOUNDER
# define PROTECTA
# define PEACE
# define PEACEQ
#elif defined(TITAN)
# define IRCD       "Titan"
# define NETADMIN
# define SWHOIS
# define DEFHALFOP
# define DEFPROTECT
# define DEFHOSTSERV
# define SJOIN
# define SSJOIN
# define SJ3
# define CFOUNDER
# define PROTECTA
# define PEACE
# define PEACEP
#elif defined(ULTIMATE2)
# define IRCD       "Ultimate 2.8x"
# define NETADMIN
# define DEFHALFOP
# define DEFPROTECT
# define DEFHOSTSERV
# define CLINK
# define CFLOOD
# define CFOUNDER
# define PROTECTA
# define PEACE
# define PEACEQ
#elif defined(ULTIMATE)
# define IRCD       "Ultimate 3.x"
# define NETADMIN
# define DEFHALFOP
# define DEFPROTECT
# define DEFHOSTSERV
# define CLINK
# define SJOIN
# define SJ3
# define SSJOIN
# define CFLOOD
# define CFOUNDER
# define PROTECTA
# define PEACE
# define PEACEQ
# define BAHAMUT
#elif defined(BAHAMUT)
# define IRCD "Bahamut"
# define SJOIN
# define SSJOIN
#endif


#if defined(BAHAMUT)
# define NEWNICK(nick,user,host,real,modes,qline) \
    do { \
        send_cmd(NULL, "NICK %s 1 %ld %s %s %s %s 0 :%s", (nick), time(NULL), (modes), \
                (user), (host), SERVER_NAME, (real)); \
        if ((qline)) send_cmd(NULL, "SQLINE %s :Reserved for services", (nick)); \
    } while (0)
# define CNEWNICK(nick,user,host,real,modes,qline) \
    do { \
        send_cmd(NULL, "NICK %s 1 0 %s %s %s 1 + * :%s", (nick),\
                (user), (host), SERVER_NAME, (real)); \
    } while (0)

#elif defined(UNREAL)
# define NEWNICK(nick,user,host,real,modes,qline) \
    do { \
        send_cmd(NULL, "NICK %s 1 %ld %s %s %s 0 %s %s :%s", (nick), time(NULL),\
                (user), (host), SERVER_NAME, (modes), (host), (real)); \
        if (strcmp(modes, "+")) send_cmd((nick), "MODE %s %s", (nick), (modes)); \
        if ((qline)) send_cmd(NULL, "SQLINE %s :Reserved for services", (nick)); \
    } while (0)
# define CNEWNICK(nick,user,host,real,modes,qline) \
    do { \
        send_cmd(NULL, "NICK %s 1 0 %s %s %s 0 + %s :%s", (nick), \
                (user), (host), SERVER_NAME, (host), (real)); \
    } while (0)
#else
# define NEWNICK(nick,user,host,real,modes,qline) \
    do { \
        send_cmd(NULL, "NICK %s 1 %ld %s %s %s 0 :%s", (nick), time(NULL),\
                (user), (host), SERVER_NAME, (real)); \
        if (strcmp(modes, "+")) send_cmd((nick), "MODE %s %s", (nick), (modes)); \
        if ((qline)) send_cmd(NULL, "SQLINE %s :Reserved for services", (nick)); \
    } while (0)
# define CNEWNICK(nick,user,host,real,modes,qline) \
    do { \
        send_cmd(NULL, "NICK %s 1 0 %s %s %s 0 :%s", (nick), \
                (user), (host), SERVER_NAME, (real)); \
    } while (0)
#endif


typedef struct author_ Auths;
struct author_ {
        char *who;              /* Who request Auth */
        char *chan;				/* Request for chan */
        long flags;				/* What kind of request ? */
        time_t time;
	long number;
};

typedef struct authlist_ AuthList;

struct authlist_ {
    AuthList *next, *prev;
    char nick[NICKMAX]; /* Owner of the auth */
    long n_memos;       /* Number of auth */
    Auths *memos;        /* The auth themselves */
};

#define AUTH_UOP	0x00000001  /* Add to UOP */
#define AUTH_VOP	0x00000002  /* Add to VOP */
#define AUTH_HOP	0x00000004
#define AUTH_AOP	0x00000008
#define AUTH_SOP	0x00000010
#define AUTH_CFOUNDER	0x00000020
#define AUTH_SUCCESS	0x00000040

typedef struct admininfo_ AdminInfo;
struct admininfo_ {
        AdminInfo *next, *prev;
        char *nick;             /* Admin Nickname*/
        char *host;             /* Admin host */
        char *who;		/* Who add this admin */
	char *server;
	char **mark;		/* Make by Services Root flag mark */
	long markline;
        long adflags;           /* Admin Flags */
        long flags;		/* What this Admin Can Do ? */
        time_t added;
};

#define ADF_HELPOP		0x00000001
#define ADF_SERVICEOP		0x00000002
#define ADF_SERVICEADMIN	0x00000004
#define ADF_SERVICEROOT		0x00000008

#define AI_ADDSRA		0x00000001 /* Can add SRA */
#define AI_ADDSA		0x00000002 /* Can add SA */
#define AI_HOLD			0x00000004 /* can do hold */
#define AI_GLOBAL		0x00000008 /* can send global message */
#define AI_SINGLE		0x00000010 /* Only have access in his own server */
#define AI_SUPEROP		0x00000020 /* Always AOP */
#define AI_AKILL		0x00000040 /* can do akill */
#define AI_FORCEJOIN		0x00000080 /* can do force join */
#define AI_ABUSETM		0x00000100 /* Abuse Team */
#define AI_QUIT			0x00000200 /* Suspend From Rank */
#define AI_FORBID		0x00000400 /* Can do forbid */
#define AI_IGNORE		0x00000800 /* ignore tigger */
#define AI_NICKOP		0x00001000 /* Nick Operator, setnick flag */
#define AI_CHANOP		0x00002000 /* chan Operator */
#define AI_NPASS		0x00004000 /* nick password */
#define AI_CPASS		0x00008000 /* chan password */
#define AI_CLOSE		0x00010000 /* chan closure */	
#define AI_BOTSERV		0x00020000 /* BotServ */	
#define AI_GPASS		0x00040000 /* Get password */	
#define AI_FREEZE		0x00080000 /* Freeze */	

extern void load_admin_db(void);
extern void save_admin_db(void);
extern AdminInfo *findadmin(const char *nick);
extern void adminserv(const char *source, char *buf);
extern char *s_AdminServ;
extern AdminInfo *adminlists[256];
extern int is_oper_cando(const char *source, int operflag);
extern void do_lautoop (const char *nick, const char *chan, int acc);
extern void do_sendaccept(const char *source, char *nick, char *chan, int alevel);
extern int get_file_version(FILE *f, char *filename);
extern void kill_user(const char *source, const char *user, const char *reason);
extern unsigned char char_atribs[];
extern time_t CTime;
extern int MailValidate(const char *email);
// extern int is_chanbadwords(ChannelInfo *ci, char *text);

#define MAXLEN		512
#define HOSTLEN		64
#define PRINT		1
#define CNTRL		2
#define ALPHA		4
#define PUNCT		8
#define DIGIT		16
#define SPACE		32
#define ALLOW		64
#define isallowed(c) (char_atribs[(u_char)(c)]&ALLOW)
#define isNum(num) (!(strspn(num,"0123456789") - strlen(num)) && strlen(num))
